searchData={"items":[{"type":"module","title":"Predicated","doc":"","ref":"Predicated.html"},{"type":"function","title":"Predicated.compile/3","doc":"Compiles the final result of testing all the predicates","ref":"Predicated.html#compile/3"},{"type":"function","title":"Predicated.date?/1","doc":"","ref":"Predicated.html#date?/1"},{"type":"function","title":"Predicated.datetime?/1","doc":"","ref":"Predicated.html#datetime?/1"},{"type":"function","title":"Predicated.eval/2","doc":"Evaluates a predicate's condition","ref":"Predicated.html#eval/2"},{"type":"function","title":"Predicated.path_and_value/2","doc":"Constructs the path used to query into the subject and extracts the expression from the subject based on that path.\n\n    iex> Predicated.path_and_value(\"person.first_name\", %{person: %{first_name: \"Bob\"}})\n    {[:person, :first_name], \"Bob\"}\n\n    iex> Predicated.path_and_value(\"first_name\", %{first_name: \"Bob\"})\n    {[:first_name], \"Bob\"}","ref":"Predicated.html#path_and_value/2"},{"type":"function","title":"Predicated.test/3","doc":"Tests a predicate","ref":"Predicated.html#test/3"},{"type":"function","title":"Predicated.to_query/1","doc":"","ref":"Predicated.html#to_query/1"},{"type":"module","title":"Predicated.Condition","doc":"","ref":"Predicated.Condition.html"},{"type":"module","title":"Predicated.Predicate","doc":"","ref":"Predicated.Predicate.html"},{"type":"function","title":"Predicated.Predicate.append_closing_paran/1","doc":"","ref":"Predicated.Predicate.html#append_closing_paran/1"},{"type":"function","title":"Predicated.Predicate.append_logical_operator/2","doc":"","ref":"Predicated.Predicate.html#append_logical_operator/2"},{"type":"function","title":"Predicated.Predicate.get_expression_value/1","doc":"","ref":"Predicated.Predicate.html#get_expression_value/1"},{"type":"function","title":"Predicated.Predicate.get_logical_operator/1","doc":"","ref":"Predicated.Predicate.html#get_logical_operator/1"},{"type":"function","title":"Predicated.Predicate.to_query/1","doc":"","ref":"Predicated.Predicate.html#to_query/1"},{"type":"module","title":"Predicated.Query","doc":"","ref":"Predicated.Query.html"},{"type":"function","title":"Predicated.Query.cast/1","doc":"","ref":"Predicated.Query.html#cast/1"},{"type":"function","title":"Predicated.Query.cast_boolean/1","doc":"","ref":"Predicated.Query.html#cast_boolean/1"},{"type":"function","title":"Predicated.Query.cast_date/1","doc":"","ref":"Predicated.Query.html#cast_date/1"},{"type":"function","title":"Predicated.Query.cast_datetime/1","doc":"","ref":"Predicated.Query.html#cast_datetime/1"},{"type":"function","title":"Predicated.Query.cast_list/1","doc":"","ref":"Predicated.Query.html#cast_list/1"},{"type":"function","title":"Predicated.Query.cast_number/1","doc":"","ref":"Predicated.Query.html#cast_number/1"},{"type":"function","title":"Predicated.Query.cast_string/1","doc":"","ref":"Predicated.Query.html#cast_string/1"},{"type":"function","title":"Predicated.Query.chunk_results/1","doc":"","ref":"Predicated.Query.html#chunk_results/1"},{"type":"function","title":"Predicated.Query.compile_results/2","doc":"","ref":"Predicated.Query.html#compile_results/2"},{"type":"function","title":"Predicated.Query.date?/1","doc":"","ref":"Predicated.Query.html#date?/1"},{"type":"function","title":"Predicated.Query.datetime?/1","doc":"","ref":"Predicated.Query.html#datetime?/1"},{"type":"function","title":"Predicated.Query.get_expression/1","doc":"","ref":"Predicated.Query.html#get_expression/1"},{"type":"function","title":"Predicated.Query.get_logical_operator/1","doc":"","ref":"Predicated.Query.html#get_logical_operator/1"},{"type":"function","title":"Predicated.Query.list?/1","doc":"","ref":"Predicated.Query.html#list?/1"},{"type":"function","title":"Predicated.Query.new/1","doc":"","ref":"Predicated.Query.html#new/1"},{"type":"function","title":"Predicated.Query.number?/1","doc":"","ref":"Predicated.Query.html#number?/1"},{"type":"module","title":"Predicated.Query.Parser","doc":"","ref":"Predicated.Query.Parser.html"},{"type":"function","title":"Predicated.Query.Parser.parse/2","doc":"Parses the given `binary` as parse.\n\nReturns `{:ok, [token], rest, context, position, byte_offset}` or\n`{:error, reason, rest, context, line, byte_offset}` where `position`\ndescribes the location of the parse (start position) as `{line, offset_to_start_of_line}`.\n\nTo column where the error occurred can be inferred from `byte_offset - offset_to_start_of_line`.","ref":"Predicated.Query.Parser.html#parse/2"},{"type":"function","title":"Options - Predicated.Query.Parser.parse/2","doc":"* `:byte_offset` - the byte offset for the whole binary, defaults to 0\n  * `:line` - the line and the byte offset into that line, defaults to `{1, byte_offset}`\n  * `:context` - the initial context value. It will be converted to a map","ref":"Predicated.Query.Parser.html#parse/2-options"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v1.0.0 - 2023-11-08 - Changelog","doc":"- Initial release","ref":"changelog.html#v1-0-0-2023-11-08"},{"type":"extras","title":"License","doc":"MIT License\n\nCopyright (c) 2023 Thomas Brewer\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"extras","title":"Readme","doc":"# Predicated\n\n[![Elixir CI](https://github.com/themusicman/predicated/actions/workflows/elixir.yml/badge.svg)](https://github.com/themusicman/predicated/actions/workflows/elixir.yml)\n\nPredicated is a library that allows for building predicates to query an in-memory data structure in Elixir.","ref":"readme.html"},{"type":"extras","title":"Installation - Readme","doc":"If [available in Hex](https://hex.pm/packages/predicated), the package can be installed\nby adding `predicated` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:predicated, \"~> 1.1\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Examples - Readme","doc":"Using Structs.\n\n```elixir\npredicates = [\n    %Predicate{\n      condition: %Condition{\n        identifier: \"last_name\",\n        comparison_operator: \"==\",\n        expression: \"Armstrong\"\n      },\n      logical_operator: :and\n    },\n    %Predicate{\n      predicates: [\n        %Predicate{\n          condition: %Condition{\n            identifier: \"first_name\",\n            comparison_operator: \"==\",\n            expression: \"Joe\"\n          },\n          logical_operator: :or\n        },\n        %Predicate{\n          predicates: [\n            %Predicate{\n              condition: %Condition{\n                identifier: \"first_name\",\n                comparison_operator: \"==\",\n                expression: \"Jill\"\n              },\n              logical_operator: :and\n            },\n            %Predicate{\n              condition: %Condition{\n                identifier: \"first_name\",\n                comparison_operator: \"==\",\n                expression: \"Joe\"\n              }\n            }\n          ]\n        }\n      ],\n      logical_operator: :and\n    },\n    %Predicate{\n      condition: %Condition{\n        identifier: \"last_name\",\n        comparison_operator: \"==\",\n        expression: \"Beaver\"\n      }\n    }\n]\n\n# true && (true || (false && true)) && false\nassert Predicated.test(predicates, %{first_name: \"Joe\", last_name: \"Armstrong\"}) == false\n```\n\nThe example above could also be written with just plain maps or embedded schema as long as the data shape is the same. \n\nFor example\n\n```elixir\n%Predicate{\n  condition: %Condition{\n    identifier: \"last_name\",\n    comparison_operator: \"==\",\n    expression: \"Beaver\"\n  }\n}\n```\n\nconverted to a map would be\n\n```elixir\n%{\n  condition: %{\n    identifier: \"last_name\",\n    comparison_operator: \"==\",\n    expression: \"Beaver\"\n  }\n}\n```\n\nUsing a query string:\n\n```elixir\nassert Predicated.test(\"trace_id != 'test123' and profile_id == '123'\", %{\n  trace_id: \"test123\",\n  profile_id: \"123\"\n}) == false\n\n```\n\nSupport for grouped and nested predicates:\n\n```elixir\nassert Predicated.test(\"organization_id == '123' AND (user_id == '123' OR user_id == '456' OR (user_type == 'admin' OR user_type == 'editor'))\", %{\n  organization_id: \"123\",\n  user_id: \"767\",\n  user_type: \"admin\"\n}) == true\n\n```\n\nSupport for boolean and integers:\n\n```elixir\nassert Predicated.test(\"verified == TRUE AND post.count > 100\", %{\n  verified: true,\n  post: %{ count: 123 }\n}) == true\n\n```\n\nSupport for dates and datetimes:\n\n```elixir\nassert Predicated.test(\"dob >= '2020-01-01'::DATE\", %{\n  dob: ~D[2023-02-11]\n}) == true\n```\n\n```elixir\nassert Predicated.test(\"inserted_at >= '2020-01-01T01:50:07Z'::DATETIME\", %{\n  inserted_at: ~U[2020-01-01 10:00:00Z] \n}) == true\n```","ref":"readme.html#examples"},{"type":"extras","title":"Ecto Integration - Readme","doc":"Integrating with Ecto it a bit of a manual process at the moment. My hopes are to write some macros that make this less tedious. \n\nThe first snippet here constructs a query and then applies the predicates to the query. See the next snippet for how to apply the predicates to the Ecto query.\n\n```elixir\ndef list_events_for_topic(\n        offset: offset,\n        batch_size: batch_size,\n        topic_name: topic_name,\n        topic_identifier: topic_identifier,\n        predicates: predicates\n      ) do\n  query =\n    from_events_for_topic(topic_name: topic_name)\n    |> where(as(:events).topic_name == ^topic_name)\n    |> apply_ordering(predicates)\n    |> where(not is_nil(as(:events).occurred_at))\n    |> where_available()\n\n  query =\n    unless ER.empty?(topic_identifier) do\n      where(query, as(:events).topic_identifier == ^topic_identifier)\n    else\n      query\n    end\n\n  query =\n    if Flamel.present?(predicates) do\n      conditions = apply_predicates(predicates, nil, nil)\n      from query, where: ^conditions\n    else\n      query\n    end\n\n  ER.BatchedResults.new(query, %{\"offset\" => offset, \"batch_size\" => batch_size})\nend\n```\n\nBelow is a snippet from a [module](https://github.com/eventrelay/eventrelay/blob/main/lib/event_relay/events/predicates.ex) that takes in predicates and applies them to an Ecto query.\n\n```elixir\n\n def apply_predicates([predicate | predicates], nil, nil) do\n    # first iteration\n    conditions = apply_predicate(predicate, dynamic(true), nil)\n    apply_predicates(predicates, conditions, predicate)\n  end\n\n  def apply_predicates([predicate | predicates], conditions, previous_predicate) do\n    conditions = apply_predicate(predicate, conditions, previous_predicate)\n    apply_predicates(predicates, conditions, predicate)\n  end\n\n  def apply_predicates([], conditions, _previous_predicate) do\n    conditions\n  end\n\n  def apply_predicate(%{predicates: predicates}, conditions, previous_predicate)\n      when length(predicates) > 0 do\n    nested_conditions = apply_predicates(predicates, dynamic(true), previous_predicate)\n\n    case previous_predicate do\n      nil ->\n        dynamic([events: events], ^conditions and ^nested_conditions)\n\n      %{logical_operator: :and} ->\n        dynamic([events: events], ^conditions and ^nested_conditions)\n\n      %{logical_operator: :or} ->\n        dynamic([events: events], ^conditions or ^nested_conditions)\n    end\n  end\n\n  def apply_predicate(\n        %{\n          condition: %{identifier: \"data.\"   path, comparison_operator: \"==\", expression: value}\n        },\n        conditions,\n        previous_predicate\n      ) do\n    path = parse_path(path)\n\n    case previous_predicate do\n      nil ->\n        dynamic([events: events], ^conditions and json_extract_path(events.data, ^path) == ^value)\n\n      %{logical_operator: :and} ->\n        dynamic([events: events], ^conditions and json_extract_path(events.data, ^path) == ^value)\n\n      %{logical_operator: :or} ->\n        dynamic([events: events], ^conditions or json_extract_path(events.data, ^path) == ^value)\n\n      _ ->\n        conditions\n    end\n  end\n\n  def apply_predicate(\n        %{\n          condition: %{\n            identifier: \"context.\"   path,\n            comparison_operator: \"==\",\n            expression: value\n          }\n        },\n        conditions,\n        previous_predicate\n      ) do\n    path = parse_path(path)\n\n    case previous_predicate do\n      nil ->\n        dynamic(\n          [events: events],\n          ^conditions and json_extract_path(events.context, ^path) == ^value\n        )\n\n      %{logical_operator: :and} ->\n        dynamic(\n          [events: events],\n          ^conditions and json_extract_path(events.context, ^path) == ^value\n        )\n\n      %{logical_operator: :or} ->\n        dynamic(\n          [events: events],\n          ^conditions or json_extract_path(events.context, ^path) == ^value\n        )\n\n      _ ->\n        conditions\n    end\n  end\n\n  def apply_predicate(\n        %{\n          condition: %{identifier: field, comparison_operator: \"==\", expression: value}\n        },\n        conditions,\n        previous_predicate\n      ) do\n    field = String.to_atom(field)\n\n    case previous_predicate do\n      nil ->\n        dynamic([events: events], ^conditions and field(events, ^field) == ^value)\n\n      %{logical_operator: :and} ->\n        dynamic([events: events], ^conditions and field(events, ^field) == ^value)\n\n      %{logical_operator: :or} ->\n        dynamic([events: events], ^conditions or field(events, ^field) == ^value)\n\n      _ ->\n        conditions\n    end\n  end\n```","ref":"readme.html#ecto-integration"},{"type":"extras","title":"TODO - Readme","doc":"- [x] Implement grouped/nested predicates in the query parser\n- [x] Update docs to include example of using it with Ecto\n- [x] Better handle non-terminal conditions when predicates are malformed\n- [ ] More tests\n- [ ] Write some macros that make integrating with Ecto nicer and drier\n- [ ] Add debugger that displays all the conditions and their results\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#todo"}],"content_type":"text/markdown"}